<template>
  <div class="block-content">
    <form>
      <div class="form-content">
        <label class="form-label">Tracking Id</label>
        <select class="form-value" id="track" v-model="delivery.tracking">
          <option selected> --------- </option>
          <option v-for="parcel in parcels" :key="parcel.trackingId" :item="parcel"
          :value="parcel.trackingid" v-on:click="delivery.tracking = parcel.trackingId">
            {{parcel.trackingId}}
          </option>
        </select>
      </div>
      <div class="err" id="track-err">
        <p style="color: red;">TrackingId shouldn't be empty</p>
      </div>
      <div class="form-content">
        <label class="form-label">Recipient</label>
        <select class="form-value" id="rec" v-model="delivery.recipientId">
          <option selected> --------- </option>
          <option v-for="recipient in recipients" :key="recipient.id" :item="recipient"
          :value="recipient.id" v-on:click="delivery.recipientId = recipient.id">
            {{recipient.email}}, {{recipient.phone}}, {{recipient.street}}
          </option>
        </select>
      </div>
      <div class="err" id="rec-err">
        <p style="color: red;">recipient shouldn't be empty</p>
      </div>
      <div class="form-content">
        <label class="form-label">Sender</label>
        <select class="form-value" id="sender" v-model="delivery.senderId">
          <option selected> --------- </option>
          <option v-for="sender in senders" :key="sender.id" :item="sender"
          :value="sender.id" v-on:click="delivery.senderId = sender.id">
            {{sender.userName}} <!-- {{seneder.recipient.lastName}} -->
          </option>
        </select>
      </div>
      <div class="err" id="sender-err">
        <p style="color: red;">sender shouldn't be empty</p>
      </div>
      <div class="form-content">
        <label class="form-label">Delivery Status</label>
        <input type="text" id="status" class="form-value" v-model="delivery.status"/>
      </div>
      <div class="err" id="status-err">
        <p style="color: red;">
          possible statuses are "processing", "processed",
          "in progress", "delivered" or "rejected"
        </p>
      </div>
      <div class="form-content">
        <label class="form-label">Delivery Type</label>
        <input type="text" id="type" class="form-value" v-model="delivery.type"/>
      </div>
      <div class="err" id="type-err">
        <p style="color: red;">
          possible statuses are "standared", "international"
          or "prioritary"
        </p>
      </div>
      <div class="form-content">
        <label class="form-label">Note</label>
        <input type="text" id="note" class="form-value" v-model="delivery.note"/>
      </div>
      <div class="form-content">
        <input type="button" value="Submit and new" class="form-button"
        v-on:click="submit('Delivery')" />
        <input type="button" value="Submit" class="form-button"
        id="righter" v-on:click="submit('Deliveries')" />
      </div>
    </form>
  </div>
</template>

<script>
import axios from 'axios';

export default {
  name: 'delivery',
  props: {
    string: String,
  },
  data() {
    return {
      recipients: [],
      senders: [],
      parcels: [],
      delivery: {},
    };
  },
  mounted() {
    this.getRecipients();
    this.getParcels();
    this.getSenders();
    this.get();
  },
  methods: {
    getRecipients() {
      axios.get('http://localhost:4000/api/recipients').then(
        (result) => {
          this.recipients = result.data;
        },
      ).catch((error) => {
        console.log(error);
      });
    },
    getParcels() {
      axios.get('http://localhost:4000/api/parcels').then(
        (result) => {
          this.parcels = result.data;
        },
      ).catch((error) => {
        console.log(error);
      });
    },
    getSenders() {
      axios.get('http://localhost:4000/api/users').then(
        (result) => {
          this.senders = result.data;
        },
      ).catch((error) => {
        console.log(error);
      });
    },
    get() {
      if (this.string.length > 1) {
        axios.get(`http://localhost:4000/api/deliveries/${this.string}`).then(
          (result) => {
            this.delivery = result.data;
          },
        ).catch((error) => {
          console.log(error);
        });
      }
    },
    validateDelivery(delivery) {
      const status = ['processing', 'processed', 'in progress',
        'delivered', 'rejected',
      ];
      const type = ['standard', 'prioritary', 'international'];

      if (delivery.trackingId && delivery.senderId
        && delivery.recipientId && delivery.status
        && delivery.type && type.includes(delivery.type)
        && status.includes(delivery.status)) {
        return true;
      }
      if (!delivery.trackingId) {
        document.getElementById('track').style.borderColor = 'red';
        document.getElementById('track-err').style.display = 'block';
      }

      if (!delivery.senderId) {
        document.getElementById('sender').style.borderColor = 'red';
        document.getElementById('sender-err').style.display = 'block';
      }

      if (!delivery.recipientId) {
        document.getElementById('rec').style.borderColor = 'red';
        document.getElementById('rec-err').style.display = 'block';
      }

      if (!delivery.status || !status.includes(delivery.status)) {
        document.getElementById('status').style.borderColor = 'red';
        document.getElementById('status-err').style.display = 'block';
      }

      if (!delivery.type || !type.includes(delivery.type)) {
        document.getElementById('type').style.borderColor = 'red';
        document.getElementById('type-err').style.display = 'block';
      }
      return false;
    },
    submit(component) {
      if (this.string.length === 1) {
        if (this.validateDelivery(this.delivery)) {
          axios.post('http://localhost:4000/api/deliveries', {
            trackingId: this.delivery.trackingId,
            senderId: this.delivery.senderId,
            recipientId: this.delivery.recipietId,
            type: this.delivery.type,
            status: this.delivery.status,
            note: this.delivery.note,
          })
            .then((response) => { console.log(response); alert('succesfully saved!'); })
            .catch((e) => {
              console.log(e);
            });
          this.nullify();
          this.$emit('change-component', component);
        }
      } else if (this.validateDelivery(this.delivery)) {
        axios.patch(`http://localhost:4000/api/deliveries/${this.string}`, {
          trackingId: this.delivery.trackingId,
          senderId: this.delivery.senderId,
          recipientId: this.delivery.recipietId,
          type: this.delivery.type,
          status: this.delivery.status,
          note: this.delivery.note,
        })
          .then((response) => { console.log(response); alert('succesfully saved!'); })
          .catch((e) => {
            console.log(e);
          });

        this.$emit('change-component', component);
        this.$emit('string', 'a');
      }
    },
    nullify() {
      document.getElementById('status').value = '';
      document.getElementById('type').value = '';
      document.getElementByid('note').value = '';
    },
  },
};
</script>

<style scoped>
@import "../CSS/actionObject.css";
</style>
